/* CATALOG.H  Header file */

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <ctype.h>
#include <dos.h>
#include <mem.h>
#include <bios.h>

#define UP   -72
#define DN   -80
#define PgUp -73
#define PgDn -81
#define HOME -71
#define END  -79
#define F1   -59

#define MAXSIZ 501         /* maximum number of books in catalog */
#define ASIZ 31            /* maximum length of author's name is 30 */
#define TSIZ 51            /* maximum length of title is 50 */
#define ISIZ 21            /* maximum length of id code is 20 */

#define MAX(a,b)  (a)>(b) ? (a) : (b)
#define MIN(a,b)  (a)<(b) ? (a) : (b)

typedef struct {
  char author[ASIZ];
  char title[TSIZ];
  char ident[ISIZ];
} BOOK;

/* function prototypes */

/* CATALOG.C */
void
  create(void),
  edit(void),
  list(void),
  normal_exit(void),
  save(void);

/* CAT_IN.C */
void
  insert(BOOK),
  make_list(int),
  modify(void),
  save_restore(int),
  search(void);
int
  cmp_books(BOOK,BOOK),
  enter_book(void),
  get_destination(),
  get_start_end(int, int *, int *, char *, char *),
  read_lines(char *);

/* CAT_OUT.C */
void
  display(int *, int, char *),
  list_authors(int, int, char *),
  list_titles(int, int, char *),
  list_catalog(int, int, char *),
  print_authors(int, int, char *),
  print_titles(int, int, char *),
  print_catalog(int, int, char *);
int
  cmp_title(const void *, const void *);

/* CAT_MENU.C */
void
  box(int,int,int,int,int,int),
  high(int, int, char *),
  norm(int, int, char *);
int
  menu_select(
              int,int,int,int,          /* box corners */
              int,                      /* border: 0=none,1=single,2=double */
              char *,                   /* title, centered on top border */
              int,int,                  /* start column, row in window */
              int,                      /* currently highlighted item */
              int ltr[],                /* letters to highlight */
              char *item[]);            /* menu entries (last = NULL */

/* CAT_UTIL.C */
void
  hidecursor(void),
  showcursor(void),
  scroll(int,int,int,int,int,int,int),
  stdscrn(void);
int
  clean_name(char *s),
  clean_title(char *s),
  error_msg(char *, int, int),
  getkey(void),
  instr(char *, char *);

/* CAT_HELP.C */
void
  help(int);

/* GETSTR.C */
void
  close_up(int,int,int),
  read_char(int,int),
  read_str(char *, int, int, int),
  setcursor(int);
int
  Gstr(char *, int);

