/* CAT_HELP.C  Various help screens for CATALOG */

#include "catalog.h"

/* ----------------------------- help screens ------------------------------ */
void
help(int n)
{
  int left,top, right, bottom,row,i=0;
  extern int high_attr;

  char *help1[] = {
      "This program allows you to create a library catalog or to load ",
      "a previously saved catalog, then edit the data and save the new",
      "catalog. In editing, you may add books, modify catalog entries,",
      "search titles, authors or id codes for specified substrings, or",
      "list or print all or some of the authors, titles or entries.   ",
      " Catalog entries consist of:                                   ",
      "       Title   (50 characters or less)                         ",
      "       Author  (30 characters or less)                         ",
      "       id code (20 characters or less)                         ",
      "Every book must have a title, but the other items are optional.",
       NULL };
   char *help2[] = {
      "In editing, you may:                                       ",
      "   Add books to the current catalog,                       ",
      "",
      "   Delete or modify entries,                               ",
      "",
      "   List (to screen or printer) some or all of the authors, ",
      "titles or entries in the current catalog,                  ",
      "",
      "  Search the current catalog for a specified string in the ",
      "author, title, or id code field (The string need not be all",
      "of the field being searched, just a subset of it.)         ",
       NULL };
   char *help3[] = {
      "You may list the current authors, titles or complete entries",
      "starting with a specified start letter and going through a  ",
      "specified end letter. The list will be alphabetical and may ",
      "be displayed or sent to the printer. If no start letter is  ",
      "entered, 'A' will be used and if no end letter is given 'Z' ",
      "will be used. A start letter of 'A' will cause the listing  ",
      "to begin at the start of the catalog (even though the first ",
      "item does not start with 'A') and an end letter of 'Z' will ",
      "cause the search to continue to the end of the list.        ",
       NULL };
   char *help4[] = {
      "You may search the catalog for entries in which  ",
      "a specified string occurs in the specified field.",
      "The string sought need not be the entire field.  ",
      "All matching entries will be listed on screen.   ",
       NULL };

  switch(n) {
    case 1:           /* main menu */
      left = 7, top = 13, right = 72, bottom = 22;
      box(left,top,right,bottom,high_attr,1);
      window(left,top,right,bottom);
      while(help1[i] != NULL) {
        gotoxy(2,1+i);
        cputs(help1[i++]);
      }
      getch();
      break;
    case 2:
      left = 9, top = 13, right = 71, bottom = 23;
      box(left,top,right,bottom,high_attr,1);
      window(left,top,right,bottom);
      while(help2[i] != NULL) {
        gotoxy(2,1+i);
        cputs(help2[i++]);
      }
      getch();
      break;
    case 3:
      left = 9, top = 11, right = 71, bottom = 19;
      box(left,top,right,bottom,high_attr,1);
      window(left,top,right,bottom);
      while(help3[i] != NULL) {
        gotoxy(2,1+i);
        cputs(help3[i++]);
      }
      getch();
      break;
    case 4:
      left = 15, top = 11, right = 65, bottom = 14;
      box(left,top,right,bottom,high_attr,1);
      window(left,top,right,bottom);
      while(help4[i] != NULL) {
        gotoxy(2,1+i);
        cputs(help4[i++]);
      }
      getch();
      break;
  }
}

