/* CAT_OUT.C  Display routines for CATALOG */

#include "catalog.h"
#include "catvars.h"


/* --------------------- display books found in search ------------------ */
void
display(int *found, int n, char *title)
{
  int i,j,n1,n2,new,done;
  int left = 13, top = 3, right = 67, bottom = 24;
  int row;

  if (n == 0)
    return;
  if (n < 4)
    top = 11, bottom = top+4*n;
  else if (n== 4)
    top = 8, bottom = 24;
  else
    stdscrn();
  box(left,top,right,bottom,high_attr,2);
  gotoxy(6,1); cputs(title);
  window(left,top,right,bottom);
  n1 = 0; new = 1; done = 0;
  while (!done) {
    if (new) {
      n2 = MIN(n1+5,n);
      clrscr();
      row = 2;
      for (i=n1,j=0; i<n2; i++,j++) {
        gotoxy(2,row++);
        if (catalog[indx[found[i]]].author[0])
          cputs(catalog[indx[found[i]]].author);
        else
          cputs("Author not listed");
        gotoxy(2,row++);
        cputs(catalog[indx[found[i]]].title);
        gotoxy(2,row++);
        if (catalog[indx[found[i]]].ident[0])
          cputs(catalog[indx[found[i]]].ident);
        else
          cputs("id code not given");
        row++;
      }
      if (n > n2) {
        gotoxy(21,row);
        cputs("- More -");
      }
      new = 0;
    }
    switch(getkey()) {
      case DN:
        if (n2 < n) {
          n1++;
          new = 1;
        }
        break;
      case UP:
        if (n1 > 0) {
          n1--;
          new = 1;
        }
        break;
      case PgDn:
        if (n2 < n) {
          n1 += 5;
          new = 1;
        }
        break;
      case PgUp:
        if (n1 > 0) {
          n1 = MAX(0,n1-5);
          new = 1;
        }
        break;
      case HOME:
	if (n1 > 0) {
	  n1 = 0;
          new = 1;
        }
        break;
      case END:
        if (n1 < n-5) {
          n1 = n-5;
          new = 1;
        }
        break;
      case 13:
      case 27:
        done = 1;
    }
  }
}

/* ------------------------------------------------------------------------ */
void
list_authors(int start,int end,char *heading)
{
  int i,j,n,n1,n2,new,done,row;
  int left = 24, top = 3, right = 56, bottom = 24;
  char author[MAXSIZ][ASIZ];

  n = end - start;
  stdscrn();
  box(left,top,right,bottom,high_attr,2);
  gotoxy(17-strlen(heading)/2,1); cputs(heading);
  j = 0;
  for (i=start; i<end-1; i++) {
    if(strcmp(catalog[indx[i]].author,catalog[indx[i+1]].author) !=0 &&
        catalog[indx[i]].author[0] != 0)
      strcpy(author[j++],catalog[indx[i]].author);
  }
  if (strcmp(catalog[indx[end-1]].author,author[j-1]) != 0)
    strcpy(author[j++],catalog[indx[end-1]].author);
  n = j;
  if (n == 0) {
    strcpy(author[0], catalog[0].author);
    n = 1;
  }
  window(left,top,right,bottom);
  n1 = 0; new = 1; done = 0;
  while (!done) {
    if (new) {
      n2 = MIN(n1+21,n);
      clrscr();
      row = 1;
      for (j=n1; j<n2; j++) {
        gotoxy(2,row++);
        cputs(author[j]);
      }
      if (n > n2) {
        gotoxy(14,row);
        cputs("- More -");
      }
      new = 0;
    }
    switch(getkey()) {
      case DN:
        if (n2 < n) {
          n1++;
          new = 1;
        }
        break;
      case UP:
        if (n1 > 0) {
          n1--;
          new = 1;
        }
        break;
      case PgDn:
        if (n1+21 < n) {
          n1 = n-21;
          new = 1;
        }
        break;
      case PgUp:
        if (n1 > 0) {
          n1 = MAX(n1-21,0);
          new = 1;
        }
        break;
      case HOME:
        if (n1 > 0) {
          n1 = 0;
          new = 1;
        }
        break;
      case END:
        if (n1 < n-21) {
          n1 = n-21;
          new = 1;
        }
        break;
      case 13:
      case 27:
        done = 1;
    }
  }
}
/* ------------------------------------------------------------------------ */
void
print_authors(int start, int end, char *heading)
{
  int i,j,n,n1,n2,new,done,row;
  char author[MAXSIZ][ASIZ];
  int printer_status;

  printer_status = biosprint(2,0,0);
  if ((printer_status & 0x10) == 0) {
    error_msg("Printer not ready",32,12);
    return;
  }

  prnspaces(40-strlen(filename)/2);
  fprintf(stdprn,"%s\n\n",filename);
  prnspaces(40-strlen(heading)/2);
  fprintf(stdprn,"%s\n\n",heading);
  j = 0;
  for (i=start; i<end-1; i++) {
    if(strcmp(catalog[indx[i]].author,catalog[indx[i+1]].author) !=0 ||
        catalog[indx[i]].author[0] == 0)
      strcpy(author[j++],catalog[indx[i]].author);
  }
  if (strcmp(catalog[indx[end-1]].author,catalog[indx[end-2]].author) != 0)
    strcpy(author[indx[j++]],catalog[indx[end-1]].author);
  n = j;
  row = 6;
  for (i=0; i<n; i++) {
    if (row > 60) {
      biosprint(0,12,0);
      for (j=0; j<3; j++)
        fprintf(stdprn,"\n");
      row = 4;
    }
    prnspaces(25);
    fprintf(stdprn,"%s\n",author[indx[i]]);
    row++;
  }
}
/* ------------------------------------------------------------------------ */
void
list_titles(int start, int end, char *heading)
{
  int i,j,n,n1,n2,new,done;
  int left = 14, top = 3, right = 66, bottom = 24;
  int row;
  int *indx1;

  stdscrn();
  box(left,top,right,bottom,high_attr,2);
  gotoxy(26-strlen(heading)/2,1); cputs(heading);
  window(left,top,right,bottom);
  n1 = start; n = end; new = 1; done = 0;
  while (!done) {
    if (new) {
      n2 = MIN(n1+21,n);
      clrscr();
      row = 1;
      for (i=n1,j=0; i<n2; i++,j++) {
        gotoxy(2,row++);
        cputs(catalog[indx[i]].title);
      }
      new = 0;
    }
    if (n > n2) {
      gotoxy(21,row);
      cputs("- More -");
    }
    switch(getkey()) {
      case DN:
        if (n2 < n) {
          n1++;
          new = 1;
        }
        break;
      case UP:
        if (n1 > start) {
          n1--;
          new = 1;
        }
        break;
      case PgDn:
        if (n1+21 < n) {
          n1 = n-21;
          new = 1;
        }
        break;
      case PgUp:
        if (n1 > start) {
          n1 = MAX(n1 - 1,start);
          new = 1;
        }
        break;
      case HOME:
        if (n1 > start) {
          n1 = start;
          new = 1;
        }
        break;
      case END:
        if (n1 < n-21) {
          n1 = n-21;
          new = 1;
        }
        break;
      case 13:
      case 27:
        done = 1;
    }
  }
}

/* ---------------------------------------------------------------------- */
void
print_titles(int start, int end, char *heading)
{
  int i,j,n;
  int row;
  int printer_status;

  printer_status = biosprint(2,0,0);
  if ((printer_status & 0x10) == 0) {
    error_msg("Printer not ready",32,12);
    return;
  }

  prnspaces(40-strlen(filename)/2);
  fprintf(stdprn,"%s\n\n",filename);
  prnspaces(40-strlen(heading)/2);
  fprintf(stdprn,"%s\n\n",heading);
  row = 5;
  for (i=start; i<end; i++) {
    if (row > 60) {
      biosprint(0,12,0);
      for (j=0; j<3; j++)
        fprintf(stdprn,"\n");
      row = 4;
    }
    prnspaces(13);
    fprintf(stdprn,"%s\n",catalog[indx[i]].title);
    row++;
  }
}

/* ---------------------------------------------------------------------- */
void
list_catalog(int start, int end, char *heading)
{
  int i,j,n,n1,n2,new,done;
  int left = 14, top = 3, right = 66, bottom = 24;
  int row;

  stdscrn();
  box(left,top,right,bottom,high_attr,2);
  gotoxy(26-strlen(heading)/2,1); cputs(heading);
  window(left,top,right,bottom);
  n1 = start; n = end; new = 1; done = 0;
  while (!done) {
    if (new) {
      n2 = MIN(n1+5,n);
      clrscr();
      row = 2;
      for (i=n1; i<n2; i++) {
        gotoxy(2,row++);
        if (catalog[indx[i]].author[0])
          cputs(catalog[indx[i]].author);
        else
          cputs("Author not listed");
        gotoxy(2,row++);
        cputs(catalog[indx[i]].title);
        gotoxy(2,row++);
        if (catalog[indx[i]].ident[0])
          cputs(catalog[indx[i]].ident);
        else
          cputs("id code not given");
        row++;
      }
      if (n > n2) {
        gotoxy(21,row);
        cputs("- More -");
      }
      new = 0;
    }
    switch(getkey()) {
      case DN:
        if (n2 < n) {
          n1++;
          new = 1;
        }
        break;
      case UP:
        if (n1 > start) {
          n1--;
          new = 1;
        }
        break;
      case PgDn:
        if (n1+5 < n) {
          n1 = MIN(n1+5,n-5);
          new = 1;
        }
        break;
      case PgUp:
        if (n1 > start) {
          n1 = MAX(n1-5,0);
          new = 1;
        }
        break;
      case HOME:
        if (n1 > start) {
          n1 = start;
          new = 1;
        }
        break;
      case END:
        if (n1 < n-5) {
          n1 = n-5;
          new = 1;
        }
        break;
      case 13:
      case 27:
        done = 1;
    }
  }
}

/* ------------------------------------------------------------------------ */
void
print_catalog(int start, int end, char *heading)
{
  int i,j,n;
  int row;
  int printer_status;

  printer_status = biosprint(2,0,0);
  if ((printer_status & 0x10) == 0) {
    error_msg("Printer not ready",32,12);
    return;
  }

  prnspaces(40-strlen(filename)/2);
  fprintf(stdprn,"%s\n\n",filename);
  prnspaces(40-strlen(heading)/2);
  fprintf(stdprn,"%s\n\n",heading);
  row = 5;
  for (i=start; i<end; i++) {
    if (row > 59) {
      biosprint(0,12,0);
      for (j=0; j<3; j++)
        fprintf(stdprn,"\n");
      row = 4;
    }
    prnspaces(13);
    if (catalog[indx[i]].author[0])
      fprintf(stdprn,"%s\n",catalog[indx[i]].author);
    else
      fprintf(stdprn,"Author not given\n");
    prnspaces(13);
    fprintf(stdprn,"%s\n",catalog[indx[i]].title);
    prnspaces(13);
    if (catalog[indx[i]].ident[0])
      fprintf(stdprn,"%s\n",catalog[indx[i]].ident);
    else
      fprintf(stdprn,"id code not entered\n");
    fprintf(stdprn,"\n");
    row += 4;
  }
}

/* ------------------------------- */
prnspaces(int k)
{
  int i;

  for (i=0; i<k; i++)
    fprintf(stdprn," ");
}

/* --------------------------------- */
int
cmp_title(const void *pe1, const void *pe2)
{
  int n1 = *(int*)pe1, n2 = *(int *)pe2;
  int k = strcmpi(catalog[n1].title, catalog[n2].title);
  return k;
}

